#define INCL_WIN
#define INCL_PM

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <os2.h>

#include "Basic.hpp"
#include "Resource.hpp"

const char szClassName[] = PRODUCT;
const char szWindowTitle[] = "Untitled";

//------------------------------------------------------------------------
// Function prototype

MRESULT EXPENTRY Main_Frame(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2);

//------------------------------------------------------------------------

int main()
{
     BOOL Shutdown = FALSE;// Do we shutdown the application?

     HAB hab = WinInitialize( 0 );
     if( hab == NULLHANDLE )
     {
          WinMessageBox( HWND_DESKTOP,
                         HWND_DESKTOP,
                         (PSZ) "Unable to initialize window",
                         (PSZ) "ERROR!",
                         0,
                         MB_CANCEL | MB_ERROR );
          Shutdown = TRUE;
     }

     HMQ hmq = WinCreateMsgQueue( hab, 0 );
     if(hmq == NULLHANDLE)
     {
          WinMessageBox( HWND_DESKTOP,
                         HWND_DESKTOP,
                         (PSZ) "Unable to create a message queue",
                         (PSZ) "ERROR!",
                         0,
                         MB_CANCEL | MB_ERROR);
          Shutdown = TRUE;
     }

     if( !WinRegisterClass( hab,
                            szClassName,
                            Main_Frame,
                            CS_SIZEREDRAW,
                            4))
     {
          WinMessageBox( HWND_DESKTOP,
                         HWND_DESKTOP,
                         (PSZ) "Unable to register window class",
                         (PSZ) "ERROR!",
                         0,
                         MB_CANCEL | MB_ERROR);
          Shutdown = TRUE;
     }

     ULONG flCreateOpts = FCF_STANDARD & ~FCF_ICON;
     HWND hwndClient;
     HWND hwndFrame = WinCreateStdWindow( HWND_DESKTOP,
                          WS_VISIBLE,
                          &flCreateOpts,
                          szClassName,
                          szWindowTitle,
                          0L,
                          0,
                          IDD_FRAME_MAIN,
                          &hwndClient);
     if( hwndFrame == NULLHANDLE)
     {
          // check flCreateOpts to ensure that all the specified components are present
          WinMessageBox( HWND_DESKTOP,
                         HWND_DESKTOP,
                         (PSZ) "Unable to create standard window",
                         (PSZ) "ERROR!",
                         0,
                         MB_CANCEL | MB_ERROR);
          Shutdown = TRUE;
     }

     QMSG qmsg;
     while( !Shutdown )
     {
          // Standard message loop
          // The while loop is exited when a WM_QUIT message is received
          while(WinGetMsg(hab, &qmsg, 0, 0, 0))
               WinDispatchMsg(hab, &qmsg);

          // Let's see if we can safely close the document
          if( WinSendMsg( hwndFrame, WM_VERIFYSHUTDOWN, 0, 0 ) )
               // Work has been saved or discarded
               Shutdown = TRUE;

          if( qmsg.hwnd == NULLHANDLE && !Shutdown )
               // The work has not been saved or the user
               // cancelled the shutdown
               WinCancelShutdown( hmq, FALSE );
     }

     WinDestroyWindow(hwndFrame);
     WinDestroyMsgQueue(hmq);
     WinTerminate(hab);

     return 0;
}//end of main

