/*************************************************************************

                 Framework for Safe Document Handling
                 ------------------------------------

                 by Stephane Bessette (stephb7@usa.net)
                             Freeware @1997


Class_SafeDocumentHandling


*************************************************************************/

#ifndef CLASS_SAFEDOCUMENTHANDLING_HPP
#define CLASS_SAFEDOCUMENTHANDLING_HPP

class Class_SafeDocumentHandling {
public:
     Class_SafeDocumentHandling ( HWND _hwnd, PSZ szApplicationName );
     ~Class_SafeDocumentHandling();
     BOOL FileSave();
     BOOL FileSaveAs( BOOL bVerify = TRUE );
     BOOL FileNew();
     BOOL FileOpen( BOOL bVerify = TRUE );
     void SetModified();
//************************************************************************
protected:
     virtual BOOL Save() = 0;// Function must be redefined
     virtual BOOL Load() = 0;// Function must be redefined
     PSZ Get_Filename();
//************************************************************************
private:
     HWND hwnd;// Handle to the frame window (not to the client window!!)
     PSZ pszApplicationName;// Name of the application
     char szFilename[CCHMAXPATH];// Hold the filename of the document
     BOOL bModifiedDocument;// Is the document modified?
     BOOL CanClose( BOOL bLastChance = TRUE );
     void UpdateTitlebar();
};

#endif // CLASS_SAFEDOCUMENTHANDLING_HPP
